// 
// File:          sample_Driver_Impl.cc
// Symbol:        sample.Driver-v1.0
// Symbol Type:   class
// Babel Version: 0.10.12
// sidl Created:  20060725 07:52:38 PDT
// Generated:     20060725 07:52:48 PDT
// Description:   Server-side implementation for sample.Driver
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.10.12
// source-line   = 3
// source-url    = file:/home/amorris/performance/examples/sidl/sample.sidl
// xml-url       = /home/amorris/performance/examples/sidl/repository/sample.Driver-v1.0.xml
// 
#include "sample_Driver_Impl.hh"

// DO-NOT-DELETE splicer.begin(sample.Driver._includes)

#include <Performance_Measurement.hh>
#include <iostream>
#include <sample_Driver_Impl.hh>
// DO-NOT-DELETE splicer.end(sample.Driver._includes)

// user-defined constructor.
void sample::Driver_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._ctor)
  // DO-NOT-DELETE splicer.end(sample.Driver._ctor)
}

// user-defined destructor.
void sample::Driver_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._dtor)
  // DO-NOT-DELETE splicer.end(sample.Driver._dtor)
}

// static class initializer.
void sample::Driver_impl::_load() {
  // DO-NOT-DELETE splicer.begin(sample.Driver._load)
  // Insert-Code-Here {sample.Driver._load} (class initialization)
  // DO-NOT-DELETE splicer.end(sample.Driver._load)
}

// user-defined static methods: (none)

// user-defined non-static methods:
/**
 * Execute some encapsulated functionality on the component. 
 * Return 0 if ok, -1 if internal error but component may be 
 * used further, and -2 if error so severe that component cannot
 * be further used safely.
 */
int32_t
sample::Driver_impl::go ()
throw () 

{
  // DO-NOT-DELETE splicer.begin(sample.Driver.go)


  ::gov::cca::Port port;

  port = frameworkServices.getPort ("MeasurementPort");
  if (port._is_nil()) {
    std::cerr << "MeasurementPort is not connected" << std::endl;
    return -1;
  }

  Performance::Measurement measurement = port;


  ::Performance::ContextEvent contextEvent = measurement.createContextEventWithName("Context Event");
  
  

  for (int i = 0; i < 4; i++) {
 
    std::ostringstream os;
    os << "Iteration " << i;
    std::string phaseName = os.str();

    // Create and start a phase
    ::Performance::Phase phase = measurement.createPhaseWithName(phaseName);
    phase.start();
    
    // Create and start a timer
    static ::Performance::Timer tautimer = 
      measurement.createTimerWithNameTypeGroup("go", "int32_t ()",
					       "TAU_GROUP_CCA");
    tautimer.start();
    

    // Configure TAU with -PROFILEPARAM to use the following
    
    static ::Performance::Timer paramTimer = 
      measurement.createTimerWithNameTypeGroup("param", "", "TAU_GROUP_CCA");
    paramTimer.start();
    paramTimer.setParam1L(42,"parameter");
    paramTimer.stop();
    
    paramTimer.start();
    paramTimer.setParam1L(i,"parameter");
    paramTimer.stop();

    // Create a memory tracker and start interrupt driven memory tracking
    ::Performance::MemoryTracker tracker = 
	measurement.createMemoryTracker();
    tracker.enableInterruptTracking();
    

    contextEvent.trigger(i);
    
    sleep(i);
    
    // Manually track memory here
    tracker.trackHere();
    
    tautimer.stop();

    phase.stop();
  }

  // Create a query interface
  ::Performance::Query query = measurement.createQuery();

  // Get the event names
  ::sidl::array< ::std::string> eventNames = query.getEventNames();


  ::sidl::array<int32_t> numSamples;
  ::sidl::array<double> max, min, mean, sumSqr;

  // Get the event data
  query.getEventData(eventNames, numSamples, max, min, mean, sumSqr);

  int numEvents = eventNames.upper(0) - eventNames.lower(0) + 1;
  for (int i = 0; i < numEvents; i++) {
    std::cout << "User Event: " << eventNames.get(i) << std::endl;
    std::cout << "Number of Samples: " << numSamples.get(i) << std::endl;
    std::cout << "Maximum Value: " << max.get(i) << std::endl;
    std::cout << "Minimim Value: " << min.get(i) << std::endl;
    std::cout << "Mean Value: " << mean.get(i) << std::endl;
    std::cout << "Sum Squared: " << sumSqr.get(i) << std::endl << std::endl;

  }

  frameworkServices.releasePort("MeasurementPort");

  return 0;
  // DO-NOT-DELETE splicer.end(sample.Driver.go)
}

/**
 * Starts up a component presence in the calling framework.
 * @param services the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument Svc will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
sample::Driver_impl::setServices (
  /* in */ ::gov::cca::Services services ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(sample.Driver.setServices)


  frameworkServices = services;

  gov::cca::TypeMap tm = frameworkServices.createTypeMap();
  gov::cca::Port p = self;
    
  frameworkServices.addProvidesPort (p,
                                       "Go",
                                       "gov.cca.ports.GoPort", tm);
    
  frameworkServices.registerUsesPort ("MeasurementPort",
	                 	      "Performance.Measurement", tm);
  
  
  // DO-NOT-DELETE splicer.end(sample.Driver.setServices)
}


// DO-NOT-DELETE splicer.begin(sample.Driver._misc)
// DO-NOT-DELETE splicer.end(sample.Driver._misc)

