Summary: CCA Performance Component
Name: performance
Version: 1.1
Release: cca.1
Copyright: University of Oregon, LANL, FZJ Germany
Group: Development/Tools
Source: http://www.cs.uoregon.edu/research/paracomp/tau/cca/performance/performance-1.1.tar.gz
URL: http://www.cs.uoregon.edu/research/paracomp/tau
BuildRoot: /var/tmp/%{name}-buildroot
Requires: gcc
Requires: gcc-c++
Requires: tau >= 2.12.1

%description
The TAU performance observation component provides measurement
capabilities to components. It aids in selection of components and helps create
performance aware intelligent components. The Measurement port of the
performance component provides Timer, Query, Control and Event interfaces. The
Timer interface allows us to track performance data associated with a region of
code by bracketing it with start and stop methods. The TAU implementation of
this generic performance component interface supports both profiling and
tracing measurement options. Profiling records aggregate inclusive and
exclusive wallclock time, process virtual time, hardware performance metrics
such as data cache misses and floating point instructions executed, as well as
a combination of multiple performance metrics. The Query interface supports
both runtime and post-mortem access to these metrics for making intelligent
decisions regarding the suitability of a component. The Control interface
allows the user to control the instrumentation by enabling or disabling one or
more groups of timers and provides runtime instrumentation control capabilities
to components. The Event interface helps track application and runtime system
level atomic events and enables tracking events such as memory utilization and
the extent of inter-process message communication. The performance component
enables better integration of performance tools by separating the common
interface from its underlying implementation. Thus, the performance component
aids in the process of performance evaluation of component software.

%prep 
echo "# prep done"

%setup -q
# prepare for a post-'install' patch
echo "# setup done"


%build
export prefix=/usr/local/cca/Performance
mkdir -p $RPM_BUILD_ROOT/$prefix
mkdir -p $RPM_BUILD_ROOT/$prefix/include
mkdir -p $RPM_BUILD_ROOT/$prefix/lib
mkdir -p $RPM_BUILD_ROOT/$prefix/share
mkdir -p $RPM_BUILD_ROOT/$prefix/docs
mkdir -p $RPM_BUILD_ROOT/$prefix/share/components
mkdir -p $RPM_BUILD_ROOT/$prefix/share/xml
./configure -prefix=/usr/local/cca/Performance -taumakefile=/usr/local/cca/TAU/lib/Makefile.tau -mpihome=/usr/local/cca -cca=/usr/local -babel=/usr/local/babel -c++=g++
echo "# build done"

%install
make clean 
make

echo "Built TAU performance component"
cp ccaffeine_cxx/ports/Measurement_CCA.h /usr/local/cca/Performance/include
cp sidl/tut/integrator-component-c++/performance*h /usr/local/cca/Performance/include
cp sidl/tut/integrator-component-c++/performance*h /usr/local/cca/Performance/include
cp ccaffeine_cxx/cca-impl/libTauMeasurement_CCA.so /usr/local/cca/Performance/lib
cp sidl/tut/performance-component-c++/libPerformance-component-c++.so /usr/local/cca/Performance/lib
cp sidl/tut/repository/performance*.xml /usr/local/cca/Performance/share/xml
cp sidl/tut/performance.sidl /usr/local/cca/Performance/share
mv /usr/local/cca/Performance/include/* $RPM_BUILD_ROOT//usr/local/cca/Performance/include
mv /usr/local/cca/Performance/docs/* $RPM_BUILD_ROOT//usr/local/cca/Performance/docs
mv /usr/local/cca/Performance/lib/* $RPM_BUILD_ROOT//usr/local/cca/Performance/lib
mv /usr/local/cca/Performance/share/components/* $RPM_BUILD_ROOT//usr/local/cca/Performance/share/components
mv /usr/local/cca/Performance/share/xml/* $RPM_BUILD_ROOT//usr/local/cca/Performance/share/xml
mv /usr/local/cca/Performance/share/performance.sidl $RPM_BUILD_ROOT//usr/local/cca/Performance/share/
/bin/rm -rf /usr/local/cca/Performance
echo "Moved files"

%clean
if test "X$RPM_BUILD_ROOT" = "X/"; then
	echo "bogus RPM_BUILD_ROOT: $RPM_BUILD_ROOT. die."
fi
if test "X$RPM_BUILD_ROOT" = "X/usr"; then
	echo "bogus RPM_BUILD_ROOT: $RPM_BUILD_ROOT. die."
fi
if test "X$RPM_BUILD_ROOT" = "X/usr/local/cca/TAU"; then
	echo "bogus RPM_BUILD_ROOT: $RPM_BUILD_ROOT. die."
fi
if test "X$RPM_BUILD_ROOT" = "X/etc"; then
	echo "bogus RPM_BUILD_ROOT: $RPM_BUILD_ROOT. die."
fi
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/local/cca/Performance/include/Measurement_CCA.h
/usr/local/cca/Performance/include/performance_Control.hh
/usr/local/cca/Performance/include/performance_Event.hh
/usr/local/cca/Performance/include/performance_Measurement.hh
/usr/local/cca/Performance/include/performance_Query.hh
/usr/local/cca/Performance/include/performance_Timer.hh
/usr/local/cca/Performance/include/performance_Control_IOR.h
/usr/local/cca/Performance/include/performance_Event_IOR.h
/usr/local/cca/Performance/include/performance_Measurement_IOR.h
/usr/local/cca/Performance/include/performance_Query_IOR.h
/usr/local/cca/Performance/include/performance_Timer_IOR.h
/usr/local/cca/Performance/lib/libTauMeasurement_CCA.so
/usr/local/cca/Performance/lib/libPerformance-component-c++.so
/usr/local/cca/Performance/share/xml/performance.Control-v1.0.xml
/usr/local/cca/Performance/share/xml/performance.Event-v1.0.xml
/usr/local/cca/Performance/share/xml/performance.Measurement-v1.0.xml
/usr/local/cca/Performance/share/xml/performance.Query-v1.0.xml
/usr/local/cca/Performance/share/xml/performance.Timer-v1.0.xml
/usr/local/cca/Performance/share/xml/performance-v1.0.xml
/usr/local/cca/Performance/share/components/performance.cca
/usr/local/cca/Performance/share/components/classic.Measurement.cca
/usr/local/cca/Performance/share/performance.sidl
/usr/local/cca/Performance/docs/README
/usr/local/cca/Performance/docs/index.html



%changelog
* Wed May 14 2003 Sameer Shende <sameer@cs.uoregon.edu>
Upgraded from Babel 0.7.4 to 0.8.4. 

* Thu Mar 6 2003 Sameer Shende <sameer@cs.uoregon.edu>
TAU performance component.

